<?php

namespace Drupal\recurly_aegir\Provisioners;

/**
 * Fetches the list of sites via Aegir's Web service API.
 */
class RecurlyAegirSiteListProvisioner extends RecurlyAegirProvisioner {

  /**
   * The human-readable task type used by this provisioner.
   */
  const TASK_TYPE = 'List sites';

  /**
   * {@inheritdoc}
   */
  public static function getTaskType() {
    return self::TASK_TYPE;
  }

  /**
   * {@inheritdoc}
   *
   * Returns the list of existing sites.
   */
  public function provision() {
    $this->sendRequestAndReceiveResponse('site.json', []);
    return $this;
  }

  /**
   * Fetch the list of sites and return it.
   *
   * @return array
   *   The list of sites.
   */
  public static function getSiteList() {
    $provisioner = new static();
    $sites = $provisioner->provision()->getResponse();
    return $sites;
  }

}
